DECLARE SUB updateScrBuff (fx%, tx%, fy%, ty%)
DECLARE FUNCTION tohexD$ (number AS INTEGER)
DECLARE FUNCTION binaryD$ (number AS INTEGER)
DECLARE FUNCTION binIndex% (number%, index%)
DECLARE FUNCTION fromHex% (A$, index%)
DECLARE SUB LoadMap ()
DECLARE SUB blank ()
DECLARE SUB drawSprite (x%, y%, SPRITE%(), TScnBuf%(), TDBSXS&, TDBSYS&)
DECLARE SUB Loadgif (A$)
DECLARE SUB drawTileNB (tx%, ty%, Tile%, HF%, VF%)
DECLARE FUNCTION save% ()
DECLARE FUNCTION IVS% (number%, doit%)
DECLARE FUNCTION tohex$ (Atile AS ANY)
DECLARE FUNCTION binary$ (Atile AS ANY)
DECLARE SUB drawTileNB (tx%, ty%, Tile%, HF%, VF%)
DECLARE SUB border ()
DECLARE SUB Load (File$)
DECLARE SUB drawTile (x%, y%, Tile%, TScnBuf%(), TDBSXS&, HF%, VF%, Trans%)
DECLARE SUB SetPalette ()
DECLARE SUB Drawscreen ()
DECLARE SUB clearStringBuff ()
'Sean Tasker 2002
'seantasker@rocketmail.com
'http://icedevelopment.funky.as
'If you decide to use any source from here credit would be nice =)
'Use 16 bit per tile
'3 Maps
'Panel

TYPE TextTile
        paletteNumber AS INTEGER
        VF AS INTEGER
        HF AS INTEGER
        tileNumber AS INTEGER
END TYPE

DECLARE FUNCTION decimal (Atile AS TextTile)
DECLARE SUB putRecord (filenum%, x%, y%, xsize%, byte AS INTEGER, numrecs%)
DECLARE SUB setRecord (filenum%, x%, y%, xsize%, numrecs%)

TYPE RegType
      AX AS INTEGER
      BX AS INTEGER
      CX AS INTEGER
      DX AS INTEGER
      BP AS INTEGER
      SI AS INTEGER
      DI AS INTEGER
      FLAGS AS INTEGER
      DS AS INTEGER
      ES AS INTEGER
END TYPE

DIM Regs AS RegType
Regs.AX = 0
    CALL INTERRUPT(&H33, Regs, Regs)

REM $DYNAMIC

OPTION BASE 0

SetPalette

SCREEN 13
'ON ERROR GOTO FixError
'ERROR 6
'-------------------------------------------------------------------------
'=========================================================================
'*************************************************************************
'                   DIMS
'*************************************************************************
'=========================================================================
'-------------------------------------------------------------------------
DIM SHARED TileXSize AS INTEGER
DIM SHARED TileYSize AS INTEGER
DIM SHARED Xtiles AS INTEGER
DIM SHARED Ytiles AS INTEGER
DIM SHARED ScreenY AS INTEGER
DIM SHARED ScreenX AS INTEGER
DIM SHARED TileScreenY AS INTEGER
DIM SHARED TileScreenX AS INTEGER
DIM SHARED PanelScreenY AS INTEGER
DIM SHARED PanelScreenX AS INTEGER
DIM SHARED Screenytiles AS INTEGER
DIM SHARED Screenxtiles AS INTEGER
DIM SHARED TileScreenytiles AS INTEGER
DIM SHARED TileScreenxtiles AS INTEGER
DIM SHARED Xstep AS INTEGER
DIM SHARED Ystep AS INTEGER
DIM SHARED TXstep AS INTEGER
DIM SHARED TYstep AS INTEGER
DIM SHARED keycode AS INTEGER
DIM SHARED NumberofTiles AS INTEGER
DIM SHARED rxposition AS INTEGER
DIM SHARED TILESTEP AS INTEGER
DIM SHARED SpriteXSize AS INTEGER
DIM SHARED SpriteYSize AS INTEGER
DIM SHARED DBSXS AS LONG
DIM SHARED DBSYS AS LONG
DIM SHARED TileDBSXS AS LONG
DIM SHARED TileDBSYS AS LONG
DIM SHARED PanelDBSXS AS LONG
DIM SHARED PanelDBSYS AS LONG
DIM WindowFlag AS INTEGER
DIM MaxWindowFlag AS INTEGER
DIM SHARED tempsA AS INTEGER
DIM SHARED tempsB AS INTEGER
DIM SelectedTile AS INTEGER
DIM SelectedTileR AS INTEGER
DIM HFFlag AS INTEGER
DIM VFFlag AS INTEGER
DIM HFFlagR AS INTEGER
DIM VFFlagR AS INTEGER
DIM SHARED XNtiles%                    'On GIF
DIM SHARED YNtiles%
DIM SHARED ASTRING AS STRING
DIM SHARED tempTextTile AS TextTile
DIM SHARED fileMODE AS INTEGER
DIM SHARED PalNum AS INTEGER
DIM SHARED PalNumR AS INTEGER
DIM SHARED TMAP AS INTEGER
DIM SHARED CurrentEdit AS INTEGER
DIM SHARED ShowMaps AS INTEGER
DIM SHARED leftmousebuttonOff AS INTEGER

CONST MAP01 = 1
CONST MAP02 = 2
CONST MAP03 = 4
ShowMaps = 0

PalNum = 0
PalNumR = 0
fileMODE = 0
HFFlag = 0
VFFlag = 0
HFFlagR = 0
VFFlagR = 0
WindowFlag = 0
SelectedTile = 0
MaxWindowFlag = 3
Xstep% = 0                      'offset map is displayed
Ystep% = 0
TXstep% = 0                      'offset map is displayed
TYstep% = 0

'Setup Globals
ScreenY% = 20                   'Offsets for Map screen
ScreenX% = 18
PanelScreenX% = 1
PanelScreenY% = 20

        DO
                INPUT "Screen X Tiles:", Screenxtiles%
        LOOP UNTIL Screenxtiles% < 39 AND Screenxtiles% > 5

        DO
                INPUT "Screen Y Tiles:", Screenytiles%
        LOOP UNTIL Screenytiles% < 19 AND Screenytiles% > 5

TileScreenytiles% = 1           'Number of Tiles on Y for Tile screen
TileScreenY% = ScreenY% + Screenytiles% * 8 + 4         'Offsets for Tile screen
TileScreenX% = ScreenX%
'----------------------------
        INPUT "FILE:", File$
        IF File$ > "" THEN
                IF File$ = "1" THEN
                        Load "tedata.dat"
                ELSE
                        Load File$               'Load header of file
                END IF
        ELSE
                TileXSize% = 8
                TileYSize% = 8
                INPUT "Map X Size:", Xtiles%
                INPUT "Map Y Size:", Ytiles%
        END IF

        IF File$ = "" THEN
                INPUT "TILESET:", Tileset$
                IF Tileset$ > "" THEN Loadgif Tileset$
        ELSE
                Loadgif ASTRING$
        END IF

        IF NumberofTiles% >= 10 THEN
                TileScreenxtiles% = Screenxtiles%          'Number of Tiles on X for Tile screen
        ELSE
                TileScreenxtiles% = 10
        END IF

'Initialize Arrays
DIM SHARED TILES(TileXSize%, TileYSize%, NumberofTiles%) AS INTEGER

'Get Sprite dimentions
        READ SpriteXSize%
        READ SpriteYSize%

'Initialize sprite array
REDIM SHARED MainCharSprite(SpriteXSize% + 1, SpriteYSize% + 1) AS INTEGER

        MainCharSprite(0, 0) = SpriteXSize%
        MainCharSprite(1, 0) = SpriteYSize%

        DBSXS = Xtiles%
        IF (DBSXS * Ytiles% * 8) > 32768 THEN
                fileMODE = 1
                FileArray$ = "filarray.dat"
                LOCATE 24, 1: PRINT "Map too large for memory";
                LOCATE 25, 1: PRINT "Enabling File Mode";
        ELSE
                DIM SHARED map(Xtiles%, Ytiles%, 3) AS INTEGER
        END IF

        'fill sprite array
        FOR y% = 1 TO MainCharSprite(1, 0)
                FOR x% = 1 TO MainCharSprite(0, 0)
                        READ MainCharSprite(x%, y%)
                NEXT x%
        NEXT y%

        'SetupPanel
        DIM PanelButtons(16, 5, 5)

        FOR z% = 0 TO 4
                FOR y% = 0 TO 4
                        FOR x% = 0 TO 15
                                READ PanelButtons(x%, y%, z%)
                        NEXT x%
                NEXT y%
        NEXT z%

        IF File$ > "" THEN
                'Load from file Map data
                FOR y% = 0 TO Ytiles% - 1
                        FOR x% = 0 TO Xtiles% - 1
                                INPUT #1, map(x%, y%, 0)
                        NEXT x%
                NEXT y%
        ELSE

                IF fileMODE = 1 THEN
                        OPEN FileArray$ FOR BINARY AS #2
                END IF

                FOR y% = 0 TO Ytiles% - 1
                        FOR x% = 0 TO Xtiles% - 1
                                IF fileMODE = 1 THEN
                                        tempTextTile.tileNumber = 0
                                        tempTextTile.HF = 0
                                        tempTextTile.VF = 0
                                        tempTextTile.paletteNumber = 0
                                        putRecord 2, x%, y%, Xtiles%, decimal(tempTextTile), 1
                                ELSE
                                        map(x%, y%, 0) = 0
                                END IF
                        NEXT x%
                        DBSXS = Xtiles%
                        DBSYS = x%
                        DBSYS = ((DBSYS * y%) / (DBSXS * Ytiles%)) * 100
                        IF fileMODE = 1 THEN LOCATE 25, 20: PRINT DBSYS; "%";
                NEXT y%
                END IF

        'Load from file Tile data
        FOR ty% = 0 TO YNtiles% - 1
                FOR tx% = 0 TO XNtiles% - 1
                        FOR y% = 0 TO TileYSize% - 1
                                FOR x% = 0 TO TileXSize% - 1
                                        IF tx% < NumberofTiles% THEN TILES(x%, y%, tx% + (ty% * XNtiles%)) = POINT(x% + (tx% * 8), y% + (ty% * 8))
                                NEXT x%
                        NEXT y%
                NEXT tx%
        NEXT ty%

CLOSE #1                'finished with file
CLS
'-------------------------------------------------------------------------
'=========================================================================
'*************************************************************************
'                   DOUBLE BUFFER ARRAY/SETUP
'*************************************************************************
'=========================================================================
'-------------------------------------------------------------------------
'Create 3 double buffers (Map, Tiles and Panel)
        DIM SHARED TileBuf(((TileScreenxtiles% * TileXSize%) * (TileScreenytiles% * TileYSize%)) / 2) AS INTEGER
        DIM SHARED PanelBuf(16 * 40) AS INTEGER
        DIM SHARED ScnBuf(((Screenxtiles% * 4) * (Screenytiles% * TileYSize%)))  AS INTEGER
       
        DBSXS& = ((Screenxtiles% * TileXSize%))
        DBSYS& = Screenytiles% * TileYSize%
        ScnBuf(0) = DBSXS& * 8
        ScnBuf(1) = DBSYS&
                
        TileDBSXS& = ((TileScreenxtiles% * TileXSize%))
        TileDBSYS& = TileScreenytiles% * TileYSize%
        TileBuf%(0) = TileDBSXS& * 8
        TileBuf%(1) = TileDBSYS&

        PanelDBSXS& = 16
        PanelDBSYS& = 40
        PanelBuf%(0) = PanelDBSXS& * 8
        PanelBuf%(1) = PanelDBSYS&

'-----------------------------------------------
'Include for FPS update (1 of 2)
        ON TIMER(1) GOSUB fpscount
        TIMER ON
'-------------------------------------------------------------------------
'=========================================================================
'*************************************************************************
'                               MainLoop
'*************************************************************************
'=========================================================================
'-------------------------------------------------------------------------
        border
DO
resumingHere:
'Include for FPS update (2 of 2)
        fps = fps + 1
'-------------draw buffers-----------
'NOTE: Doesn't draw using BASIC routines pokes striaght into the Double buffer
        IF WindowFlag = 0 THEN updateScrBuff tempsA - Xstep%, tempsA + 1 - Xstep%, tempsB - Ystep%, tempsB + 1 - Ystep%

        'Draw Tile Window
        IF WindowFlag = 1 THEN
                FOR z% = 0 TO TileScreenxtiles% - 1
                        drawTile z%, 0, z% + TILESTEP, TileBuf%(), TileDBSXS&, 0, 0, 0
                NEXT z%
        END IF
              
        'draw Panel
        IF WindowFlag = 2 THEN
                FOR z% = 0 TO 2
                        FOR y% = 0 TO 4
                                FOR x% = 0 TO 15
                                        DEF SEG = VARSEG(PanelBuf%(0))
                                        yyyy& = (z% * 10 + y%) * PanelDBSXS&
                                        colour% = PanelButtons(x%, y%, z%)
                                        IF colour% = 255 THEN IF CurrentEdit% = z% THEN colour% = 14 ELSE colour% = 0
                                        IF x% < PanelDBSXS& THEN POKE (VARPTR(PanelBuf%(2)) + yyyy& + x%), colour%
                                NEXT x%
                        NEXT y%
                NEXT z%

                FOR y% = 0 TO 4
                        FOR x% = 0 TO 15
                                DEF SEG = VARSEG(PanelBuf%(0))
                                yyyy& = (5 + y%) * PanelDBSXS&
                                IF ShowMaps AND MAP01 THEN colour% = PanelButtons(x%, y%, 3) ELSE colour% = PanelButtons(x%, y%, 4)
                                IF x% < PanelDBSXS& THEN POKE (VARPTR(PanelBuf%(2)) + yyyy& + x%), colour%
                                yyyy& = (15 + y%) * PanelDBSXS&
                                IF ShowMaps AND MAP02 THEN colour% = PanelButtons(x%, y%, 3) ELSE colour% = PanelButtons(x%, y%, 4)
                                IF x% < PanelDBSXS& THEN POKE (VARPTR(PanelBuf%(2)) + yyyy& + x%), colour%
                                yyyy& = (25 + y%) * PanelDBSXS&
                                IF ShowMaps AND MAP03 THEN colour% = PanelButtons(x%, y%, 3) ELSE colour% = PanelButtons(x%, y%, 4)
                        IF x% < PanelDBSXS& THEN POKE (VARPTR(PanelBuf%(2)) + yyyy& + x%), colour%
                        NEXT x%
                NEXT y%
                DEF SEG
        END IF

'Get Mouse stats/INPUT
        Regs.AX = 3
        CALL INTERRUPT(&H33, Regs, Regs)
        oldxpos = xposition
        oldypos = yposition
        leftmousebutton = Regs.BX AND 1             'These values are
        rightmousebutton = (Regs.BX AND 2) \ 2      'placed in Regs by BIOS
        middlemousebutton = (Regs.BX AND 4) \ 4     'when you perform the
        yposition = Regs.DX                         'call.
        xposition = Regs.CX
        rxposition = (xposition / 2) - .1
        tempsA = ((rxposition / TileXSize%) - .4) + Xstep%
        tempsB = ((yposition / TileYSize%) - .4) + Ystep%
        keycode% = INP(&H60)

'If TAB change window. includes jump once for per press + release
        IF keycode% = 15 THEN
                IF nomiddlemousebutton = 1 THEN
                        nomiddlemousebutton = 0
                        WindowFlag = WindowFlag + 1
                        IF WindowFlag = MaxWindowFlag THEN WindowFlag = 0
                END IF
        ELSE
                nomiddlemousebutton = 1
        END IF

'Window watchers: "Windows" = buffers
        IF WindowFlag = 2 THEN
                Regs.AX = 7
                Regs.CX = 0
                Regs.DX = 31
                        CALL INTERRUPT(&H33, Regs, Regs)
                Regs.AX = 8
                Regs.CX = 0
                Regs.DX = 39
                        CALL INTERRUPT(&H33, Regs, Regs)
      
                drawSprite rxposition / 1, yposition / 1, MainCharSprite(), PanelBuf%(), PanelDBSXS&, PanelDBSYS&
        ELSEIF WindowFlag = 1 THEN
                Regs.AX = 7
                Regs.CX = 0
                Regs.DX = (TileScreenxtiles% * TileXSize% * 2) - 1
                        CALL INTERRUPT(&H33, Regs, Regs)
                Regs.AX = 8
                Regs.CX = 0
                Regs.DX = TileScreenytiles% * TileYSize% - 1
                        CALL INTERRUPT(&H33, Regs, Regs)
                drawSprite rxposition / 1, yposition / 1, MainCharSprite(), TileBuf%(), TileDBSXS&, TileDBSYS&
        ELSE
                Regs.AX = 7
                Regs.CX = 0
                Regs.DX = (Screenxtiles% * TileXSize% * 2) - 1
                        CALL INTERRUPT(&H33, Regs, Regs)
                Regs.AX = 8
                Regs.CX = 0
                Regs.DX = Screenytiles% * TileYSize% - 1
                        CALL INTERRUPT(&H33, Regs, Regs)

                drawSprite rxposition / 1, yposition / 1, MainCharSprite(), ScnBuf%(), DBSXS&, DBSYS&
        END IF
       
'Draw buffers to the screen
        PUT (ScreenX%, ScreenY%), ScnBuf, PSET
        PUT (TileScreenX%, TileScreenY%), TileBuf, PSET
        PUT (PanelScreenX%, PanelScreenY%), PanelBuf, PSET
           
'Show selected tiles
        drawTileNB 2, 2, SelectedTile, HFFlag, VFFlag
        drawTileNB 12, 2, SelectedTileR, HFFlagR, VFFlagR

'Input testing...
keycode% = INP(&H60)
ASTRING$ = INKEY$
        SELECT CASE keycode%
                CASE 75
                        keyOff = 0
                        IF WindowFlag = 1 THEN IF TILESTEP > 0 THEN TILESTEP = TILESTEP - 1
                        IF WindowFlag = 0 THEN IF Xstep% > 0 THEN Xstep% = Xstep% - 1
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE 77
                        keyOff = 0
                        IF WindowFlag = 1 THEN IF TILESTEP + TileScreenxtiles% < NumberofTiles THEN TILESTEP = TILESTEP + 1
                        IF WindowFlag = 0 THEN IF Xstep% + Screenxtiles% < Xtiles% THEN Xstep% = Xstep% + 1
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE 72
                        keyOff = 0
                        IF Ystep% > 0 THEN Ystep% = Ystep% - 1
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE 80
                        keyOff = 0
                        IF Ystep% + Screenytiles% < Ytiles% THEN Ystep% = Ystep% + 1
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles%
                CASE 16
                        TIMER OFF
                        blank
                        clearStringBuff
                        LOCATE 25, 1: INPUT ; "Quit? Y/N:", FileArray$
                        IF UCASE$(FileArray$) = "Y" THEN CLOSE #1: END
                        CLS : border
                        TIMER ON
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE 24
                        TIMER OFF
                        blank
                        LOCATE 25, 1: INPUT ; "Left Palette:", PalNum
                        CLS : border
                        TIMER ON
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE 25
                        TIMER OFF
                        blank
                        LOCATE 25, 1: INPUT ; "Right Palette:", PalNumR
                        CLS : border
                        TIMER ON
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE 71
                        IF keyOff = 1 THEN IF HFFlag = 0 THEN HFFlag = 1 ELSE HFFlag = 0
                        keyOff = 0
                CASE 73
                        IF keyOff = 1 THEN IF HFFlagR = 0 THEN HFFlagR = 1 ELSE HFFlagR = 0
                        keyOff = 0
                CASE 79
                        IF keyOff = 1 THEN IF VFFlag = 0 THEN VFFlag = 1 ELSE VFFlag = 0
                        keyOff = 0
                CASE 81
                        IF keyOff = 1 THEN IF VFFlagR = 0 THEN VFFlagR = 1 ELSE VFFlagR = 0
                        keyOff = 0
                CASE 31
                        clearStringBuff
                        saving = save
                        CLS : border
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE 38
                        clearStringBuff
                        LoadMap
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE 19
                        TIMER OFF
                        clearStringBuff
                        blank
                        LOCATE 25, 1: INPUT ; "Replace selected Left W/ Right? Y/N:", FileArray$
                        IF UCASE$(FileAr0ray$) = "Y" THEN
                                FOR y% = 0 TO Ytiles% - 1
                                        FOR x% = 0 TO Xtiles% - 1
                                                TMAP = map(x%, y%, CurrentEdit%)
                                                A$ = "0x" + tohexD$(TMAP)
                                                tempTextTile.paletteNumber = fromHex%(A$, 3)
                                                tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                                tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                                tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)

                                                IF tempTextTile.tileNumber = SelectedTile THEN
                                                        IF fileMODE = 1 THEN
                                                                tempTextTile.tileNumber = SelectedTileR
                                                                tempTextTile.HF = HFFlagR
                                                                tempTextTile.VF = VFFlagR
                                                                tempTextTile.paletteNumber = PalNumR
                                                                putRecord 2, x%, y%, Xtiles%, decimal(tempTextTile), 1
                                                        ELSE
                                                                tempTextTile.tileNumber = SelectedTileR
                                                                tempTextTile.HF = HFFlagR
                                                                tempTextTile.VF = VFFlagR
                                                                tempTextTile.paletteNumber = PalNumR
                                                                map(x%, y%, CurrentEdit%) = decimal(tempTextTile)
                                                        END IF
                                                END IF
                                        NEXT x%
                                NEXT y%
                        END IF
                        CLS : border
                        TIMER ON
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE 18
                        TIMER OFF
                        clearStringBuff
                        blank
                        LOCATE 25, 1: PRINT "Direction 1-" + CHR$(24) + " 20-" + CHR$(25) + " 3- 4-";
                        LOCATE 25, 26: INPUT ; Direction%
                        SELECT CASE Direction%
                                CASE 1
                                        FOR y% = 0 TO Ytiles% - 1
                                                FOR x% = 0 TO Xtiles% - 1
                                                        IF fileMODE = 1 THEN
                                                                IF y% = Ytiles% - 1 THEN
                                                                        tempTextTile.tileNumber = 0
                                                                        tempTextTile.HF = 0
                                                                        tempTextTile.VF = 0
                                                                        tempTextTile.paletteNumber = 0
                                                                        putRecord 2, x%, y%, Xtiles%, decimal(tempTextTile), 1
                                                                ELSE
                                                                        setRecord 2, x%, y% + 1, Xtiles%, 1
                                                                        GET 2, , tempTextTile.tileNumber
                                                                        A$ = "0x" + tohexD$(tempTextTile.tileNumber)
                                                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                                                        putRecord 2, x%, y%, Xtiles%, decimal(tempTextTile), 1
                                                                END IF
                                                        ELSE
                                                                IF y% = Ytiles% - 1 THEN
                                                                        map(x%, y%, CurrentEdit%) = 0
                                                                ELSE
                                                                        map(x%, y%, CurrentEdit%) = map(x%, y% + 1, CurrentEdit%)
                                                                END IF
                                                        END IF
                                                NEXT x%
                                        NEXT y%
                                CASE 2
                                        FOR y% = Ytiles% - 1 TO 0 STEP -1
                                                FOR x% = 0 TO Xtiles% - 1
                                                        IF fileMODE = 1 THEN
                                                                IF y% = 0 THEN
                                                                        tempTextTile.tileNumber = 0
                                                                        tempTextTile.HF = 0
                                                                        tempTextTile.VF = 0
                                                                        tempTextTile.paletteNumber = 0
                                                                        putRecord 2, x%, y%, Xtiles%, decimal(tempTextTile), 1
                                                                ELSE
                                                                        setRecord 2, x%, y% - 1, Xtiles%, 1
                                                                        GET 2, , tempTextTile.tileNumber
                                                                        A$ = "0x" + tohexD$(tempTextTile.tileNumber)
                                                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                                                        putRecord 2, x%, y%, Xtiles%, decimal(tempTextTile), 1
                                                                END IF
                                                        ELSE
                                                                IF y% = 0 THEN
                                                                        map(x%, y%, CurrentEdit%) = 0
                                                                ELSE
                                                                        map(x%, y%, CurrentEdit%) = map(x%, y% - 1, CurrentEdit%)
                                                                END IF
                                                        END IF
                                                NEXT x%
                                        NEXT y%
                                CASE 3
                                        FOR y% = 0 TO Ytiles% - 1
                                                FOR x% = 0 TO Xtiles% - 1
                                                        IF fileMODE = 1 THEN
                                                                IF x% = Xtiles% - 1 THEN
                                                                        tempTextTile.tileNumber = 0
                                                                        tempTextTile.HF = 0
                                                                        tempTextTile.VF = 0
                                                                        tempTextTile.paletteNumber = 0
                                                                        putRecord 2, x%, y%, Xtiles%, decimal(tempTextTile), 1
                                                                ELSE
                                                                        setRecord 2, x% + 1, y%, Xtiles%, 1
                                                                        GET 2, , tempTextTile.tileNumber
                                                                        A$ = "0x" + tohexD$(tempTextTile.tileNumber)
                                                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                                                        putRecord 2, x%, y%, Xtiles%, decimal(tempTextTile), 1
                                                                END IF
                                                        ELSE
                                                                IF x% = Xtiles% - 1 THEN
                                                                        map(x%, y%, CurrentEdit%) = 0
                                                                ELSE
                                                                        map(x%, y%, CurrentEdit%) = map(x% + 1, y%, CurrentEdit%)
                                                                END IF
                                                        END IF
                                                NEXT x%
                                        NEXT y%
                                CASE 4
                                        FOR y% = 0 TO Ytiles% - 1
                                                FOR x% = Xtiles% - 1 TO 0 STEP -1
                                                        IF fileMODE = 1 THEN
                                                                IF x% = 0 THEN
                                                                        tempTextTile.tileNumber = 0
                                                                        tempTextTile.HF = 0
                                                                        tempTextTile.VF = 0
                                                                        tempTextTile.paletteNumber = 0
                                                                        putRecord 2, x%, y%, Xtiles%, decimal(tempTextTile), 1
                                                                ELSE
                                                                        setRecord 2, x% - 1, y%, Xtiles%, 1
                                                                        GET 2, , tempTextTile.tileNumber
                                                                        A$ = "0x" + tohexD$(tempTextTile.tileNumber)
                                                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                                                        putRecord 2, x%, y%, Xtiles%, decimal(tempTextTile), 1
                                                                END IF
                                                        ELSE
                                                                IF x% = 0 THEN
                                                                        map(x%, y%, CurrentEdit%) = 0
                                                                ELSE
                                                                        map(x%, y%, CurrentEdit%) = map(x% - 1, y%, CurrentEdit%)
                                                                END IF
                                                        END IF
                                                NEXT x%
                                        NEXT y%
                                CASE ELSE
                                END SELECT
                        CLS : border
                        TIMER ON
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE 22
                        TIMER OFF
                        clearStringBuff
                        blank
                        LOCATE 25, 1: INPUT ; "Clear map with left tile? Y/N:", FileArray$
                        IF UCASE$(FileArray$) = "Y" THEN
                                FOR y% = 0 TO Ytiles% - 1
                                        FOR x% = 0 TO Xtiles% - 1
                                                IF fileMODE = 1 THEN
                                                        tempTextTile.tileNumber = SelectedTile
                                                        tempTextTile.HF = HFFlag
                                                        tempTextTile.VF = VFFlag
                                                        tempTextTile.paletteNumber = PalNum
                                                        putRecord 2, x%, y%, Xtiles%, decimal(tempTextTile), 1
                                                ELSE
                                                        tempTextTile.tileNumber = SelectedTile
                                                        tempTextTile.HF = HFFlag
                                                        tempTextTile.VF = VFFlag
                                                        tempTextTile.paletteNumber = PalNum
                                                        map(x%, y%, CurrentEdit%) = decimal(tempTextTile)
                                                END IF
                                        NEXT x%
                                NEXT y%
                        END IF
                        CLS : border
                        TIMER ON
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE 50
                        TIMER OFF
                        blank
                        LOCATE 25, 1: PRINT "$"; FRE(""); "-1"; FRE(-1); "-2"; FRE(-2);
                        SLEEP
                        blank
                        TIMER ON
                CASE 76
                        TIMER OFF
                        blank
                        LOCATE 25, 1: INPUT ; "Edit layer:", CurrentEdit%
                        IF CurrentEdit% > 3 THEN CurrentEdit% = 3
                        IF CurrentEdit% < 1 THEN CurrentEdit% = 1
                        CurrentEdit% = CurrentEdit% - 1
                        blank
                        TIMER ON
                        updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                CASE ELSE
                        keyOff = 1
        END SELECT

        IF leftmousebutton THEN
                IF WindowFlag = 0 THEN
                        IF (tempsA < Xtiles%) AND (tempsB < Ytiles%) THEN
                                IF fileMODE = 1 THEN
                                        tempTextTile.tileNumber = SelectedTile
                                        tempTextTile.HF = HFFlag
                                        tempTextTile.VF = VFFlag
                                        tempTextTile.paletteNumber = PalNum
                                        putRecord 2, tempsA, tempsB, Xtiles%, decimal(tempTextTile), 1
                                ELSE
                                        tempTextTile.tileNumber = SelectedTile
                                        tempTextTile.HF = HFFlag
                                        tempTextTile.VF = VFFlag
                                        tempTextTile.paletteNumber = PalNum
                                        map(tempsA, tempsB, CurrentEdit%) = decimal(tempTextTile)
                                END IF
                        END IF
                ELSEIF WindowFlag = 1 THEN
                        tempsA = ((rxposition / TileXSize%) - .4)
                        IF (tempsA < NumberofTiles) THEN SelectedTile = tempsA + TILESTEP
                ELSEIF WindowFlag = 2 THEN
                        IF leftmousebuttonOff = 1 THEN
                                leftmousebuttonOff = 0
                                TMAP = ((yposition / 10) - .4)
                                IF TMAP = 0 THEN
                                        IF (ShowMaps AND MAP01) <= 0 THEN
                                                ShowMaps = ShowMaps OR MAP01
                                        ELSE
                                                ShowMaps = ShowMaps AND NOT MAP01
                                        END IF
                                END IF
                                IF TMAP = 1 THEN
                                        IF (ShowMaps AND MAP02) <= 0 THEN
                                                ShowMaps = ShowMaps OR MAP02
                                        ELSE
                                                ShowMaps = ShowMaps AND NOT MAP02
                                        END IF
                                END IF
                                IF TMAP = 2 THEN
                                        IF (ShowMaps AND MAP03) <= 0 THEN
                                                ShowMaps = ShowMaps OR MAP03
                                        ELSE
                                                ShowMaps = ShowMaps AND NOT MAP03
                                        END IF
                                END IF
                                updateScrBuff 0, Screenxtiles% - 1, 0, Screenytiles% - 1
                        END IF
                END IF
        ELSE
                leftmousebuttonOff = 1
        END IF

        IF rightmousebutton THEN
                IF WindowFlag = 0 THEN
                        IF (tempsA < Xtiles%) AND (tempsB < Ytiles%) THEN
                                IF fileMODE = 1 THEN
                                        tempTextTile.tileNumber = SelectedTileR
                                        tempTextTile.HF = HFFlagR
                                        tempTextTile.VF = VFFlagR
                                        tempTextTile.paletteNumber = PalNumR
                                        putRecord 2, tempsA, tempsB, Xtiles%, decimal(tempTextTile), 1
                                ELSE
                                        tempTextTile.tileNumber = SelectedTileR
                                        tempTextTile.HF = HFFlagR
                                        tempTextTile.VF = VFFlagR
                                        tempTextTile.paletteNumber = PalNumR
                                        map(tempsA, tempsB, CurrentEdit%) = decimal(tempTextTile)
                                END IF
                        END IF
                ELSEIF WindowFlag = 1 THEN
                        tempsA = ((rxposition / TileXSize%) - .4)
                        IF (tempsA < NumberofTiles) THEN SelectedTileR = tempsA + TILESTEP
                END IF
        END IF
LOOP

'*************************************************************************
'                               FPSSHTUFF
'*************************************************************************

fpscount:
LOCATE 25, 1: PRINT "FPS:"; fps;
fps = 0
RETURN

'*************************************************************************
'                          ERROR HANDLING
'*************************************************************************
FixError:
DO
        blank
        LOCATE 15, 1: PRINT "If you were saving or loading, try againmaking sure you enter the correct       details about the save/load"
        LOCATE 20, 1: PRINT "Error :", ERR;
        LOCATE 21, 1: PRINT "Make selection:";
        LOCATE 22, 1: PRINT "1. Save Current";
        LOCATE 23, 1: PRINT "2. Resume (May not work)";
        LOCATE 24, 1: PRINT "3. Exit Current";
        LOCATE 25, 1: PRINT ":";
        ASTRING$ = INPUT$(1)
        SELECT CASE ASTRING$
                CASE "1":
                        clearStringBuff
                        saving = save
                CASE "2":
                        RESUME resumingHere
                CASE "3":
                        END
        END SELECT
LOOP
'-------------------------------------------------------------------------
'=========================================================================
'*************************************************************************
'                               DATA
'*************************************************************************
'=========================================================================
'-------------------------------------------------------------------------
'Cursor dimentions
DATA 8, 8
'Cursor data
DATA 77,77,77,77,-1,-1,-1,-1
DATA 77,77,-1,-1,-1,-1,-1,-1
DATA 77,-1,77,-1,-1,-1,-1,-1
DATA 77,-1,-1,77,-1,-1,-1,-1
DATA -1,-1,-1,-1,-1,-1,-1,-1
DATA -1,-1,-1,-1,-1,-1,-1,-1
DATA -1,-1,-1,-1,-1,-1,-1,-1
DATA -1,-1,-1,-1,-1,-1,-1,-1


DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,14,0,0,0,14,0,0,14,14,0,0,255,0,0,0
DATA 0,14,14,0,14,14,0,14,14,14,0,0,255,255,0,0
DATA 0,14,0,14,0,14,0,0,14,14,0,0,255,0,0,0
DATA 0,14,0,0,0,14,0,14,14,14,14,0,0,0,0,0

DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,14,0,0,0,14,0,14,14,14,0,0,255,0,0,0
DATA 0,14,14,0,14,14,0,0,0,14,0,0,255,255,0,0
DATA 0,14,0,14,0,14,0,0,14,0,0,0,255,0,0,0
DATA 0,14,0,0,0,14,0,14,14,14,14,0,0,0,0,0

DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,14,0,0,0,14,0,14,14,14,14,0,255,0,0,0
DATA 0,14,14,0,14,14,0,0,0,14,0,0,255,255,0,0
DATA 0,14,0,14,0,14,0,0,0,0,14,0,255,0,0,0
DATA 0,14,0,0,0,14,0,14,14,14,0,0,0,0,0,0

DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,14,14,14,0,14,14,0,14,0,0,0,0,0,0,0
DATA 0,14,0,14,0,14,0,14,14,0,0,0,0,0,0,0
DATA 0,14,14,14,0,14,0,0,14,0,0,0,0,0,0,0
DATA 14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14

DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,14,14,14,0,14,14,14,14,14,14,0,0,0,0,0
DATA 0,14,0,14,0,14,14,0,14,14,0,0,0,0,0,0
DATA 0,14,14,14,0,14,0,0,14,0,0,0,0,0,0,0
DATA 14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14

REM $STATIC
FUNCTION binary$ (Atile AS TextTile)
        DIM number AS INTEGER
        DIM RNumber AS INTEGER
        number = decimal(Atile)
        binString$ = ""
        FOR BinFollow = 0 TO 15
                RNumber = number MOD 2
                number = (number / 2) - .4
                IF RNumber = 1 THEN
                        binString$ = binString$ + "1"
                ELSE
                        binString$ = binString$ + "0"
                END IF
        NEXT BinFollow
                FOR x = 16 TO 1 STEP -1
                        Temp$ = Temp$ + MID$(binString$, x, 1)
                NEXT x
        binary$ = Temp$
END FUNCTION

FUNCTION binaryD$ (number AS INTEGER)
        DIM RNumber AS INTEGER
        binString$ = ""
        FOR BinFollow = 0 TO 15
                RNumber = number MOD 2
                number = (number / 2) - .4
                IF RNumber = 1 THEN
                        binString$ = binString$ + "1"
                ELSE
                        binString$ = binString$ + "0"
                END IF
        NEXT BinFollow
                FOR x = 16 TO 1 STEP -1
                        Temp$ = Temp$ + MID$(binString$, x, 1)
                NEXT x
        binaryD$ = Temp$
END FUNCTION

FUNCTION binIndex% (number%, index%)
        SELECT CASE number%
                CASE 0
                        A$ = "0000"
                CASE 1
                        A$ = "0001"
                CASE 2
                        A$ = "0010"
                CASE 3
                        A$ = "0011"
                CASE 4
                        A$ = "0100"
                CASE 5
                        A$ = "0101"
                CASE 6
                        A$ = "0110"
                CASE 7
                        A$ = "0111"
                CASE 8
                        A$ = "1000"
                CASE 9
                        A$ = "1001"
                CASE 10
                        A$ = "1010"
                CASE 11
                        A$ = "1011"
                CASE 12
                        A$ = "1100"
                CASE 13
                        A$ = "1101"
                CASE 14
                        A$ = "1110"
                CASE 15
                        A$ = "1111"
                CASE ELSE
        END SELECT
                IF UCASE$(MID$(A$, index%, 1)) = "1" THEN binIndex% = 1 ELSE binIndex% = 0
END FUNCTION

SUB blank
LOCATE 25, 1: PRINT "                                        ";
END SUB

SUB border
LINE (ScreenX% - 1, ScreenY% - 1)-STEP((Screenxtiles% * 8) + 1, (Screenytiles% * 8) + 1), 14, BF
LINE (TileScreenX% - 1, TileScreenY% - 1)-STEP((TileScreenxtiles% * 8) + 1, (TileScreenytiles% * 8) + 1), 14, BF
LINE (PanelScreenX% - 1, PanelScreenY% - 1)-STEP(17, 41), 14, BF
END SUB

SUB clearStringBuff
        DO
        LOOP UNTIL INKEY$ = ""
END SUB

FUNCTION decimal (Atile AS TextTile)
        DIM TpaletteNumber AS INTEGER
        DIM TVF AS INTEGER
        DIM THF AS INTEGER
        DIM finalNum AS INTEGER

        TpaletteNumber = Atile.paletteNumber * 4096

        IF Atile.VF THEN
                TVF = 2048
        ELSE
                TVF = 0
        END IF
       
        IF Atile.HF THEN
                THF = 1024
        ELSE
                THF = 0
        END IF
        decimal = TpaletteNumber + TVF + THF + Atile.tileNumber
END FUNCTION

SUB drawSprite (x%, y%, SPRITE%(), TScnBuf%(), TDBSXS&, TDBSYS&)
DEF SEG = VARSEG(TScnBuf%(0))
        FOR yy% = 1 TO SPRITE%(1, 0)
        FOR xxx% = 1 TO SPRITE%(0, 0)
                xx% = x% + xxx% - 1
                yyyy& = (y% + yy% - 1) * TDBSXS&
                colour% = SPRITE%(xxx%, yy%)
                IF xx% < TDBSXS& AND y% + yy% < TDBSYS& + 1 THEN IF SPRITE%(xxx%, yy%) <> -1 THEN POKE (VARPTR(TScnBuf%(2)) + xx% + yyyy&), colour%
        NEXT xxx%
        NEXT yy%
END SUB

SUB drawTile (x%, y%, Tile%, TScnBuf%(), TDBSXS&, HF%, VF%, Trans%)
DEF SEG = VARSEG(TScnBuf%(0))
        FOR yy% = 0 TO TileYSize% - 1
        FOR xxx% = 0 TO TileXSize% - 1
                xx% = (x% * TileXSize%) + xxx%
                yyyy& = ((y% * TileYSize%) + yy%) * TDBSXS&
                colour% = TILES(IVS(xxx%, HF%), IVS(yy%, VF%), Tile%)
                IF Trans% THEN
                        IF xx% < TDBSXS& AND colour% THEN POKE (VARPTR(TScnBuf%(2)) + yyyy& + xx%), colour%
                ELSE
                        IF xx% < TDBSXS& THEN POKE (VARPTR(TScnBuf%(2)) + yyyy& + xx%), colour%
                END IF
        NEXT xxx%
        NEXT yy%
DEF SEG
END SUB

SUB drawTileNB (tx%, ty%, Tile%, HF%, VF%)
        FOR y% = 0 TO TileYSize% - 1
        FOR x% = 0 TO TileXSize% - 1
                PSET (tx% + x%, ty% + y%), TILES(IVS(x%, HF%), IVS(y%, VF%), Tile%)
        NEXT x%
        NEXT y%
END SUB

FUNCTION fromHex% (A$, index%)
        SELECT CASE UCASE$(MID$(A$, index%, 1))
                CASE "F"
                        fromHex% = 15
                CASE "E"
                        fromHex% = 14
                CASE "D"
                        fromHex% = 13
                CASE "C"
                        fromHex% = 12
                CASE "B"
                        fromHex% = 11
                CASE "A"
                        fromHex% = 10
                CASE ELSE
                        fromHex% = VAL(UCASE$(MID$(A$, index%, 1)))
        END SELECT
END FUNCTION

FUNCTION IVS% (number%, doit%)
        IF doit% > 0 THEN
                SELECT CASE (number%)
                        CASE 0: IVS = 7
                        CASE 1: IVS = 6
                        CASE 2: IVS = 5
                        CASE 3: IVS = 4
                        CASE 4: IVS = 3
                        CASE 5: IVS = 2
                        CASE 6: IVS = 1
                        CASE 7: IVS = 0
                END SELECT
        ELSE
                IVS = number%
       
END IF
END FUNCTION

SUB Load (File$)
OPEN File$ FOR INPUT AS #1
        INPUT #1, TileXSize%
        INPUT #1, TileYSize%
        INPUT #1, NumberofTiles%
        INPUT #1, Xtiles%
        INPUT #1, Ytiles%
        INPUT #1, ASTRING$
END SUB

SUB Loadgif (A$)
' Author unknown
DEFINT A-Z
DIM Prefix(4095), Suffix(4095), OutStack(4095), shiftout%(8)
DIM Ybase AS LONG, powersof2(11) AS LONG, WorkCode AS LONG

FOR A% = 0 TO 7: shiftout%(8 - A%) = 2 ^ A%: NEXT A%
FOR A% = 0 TO 11: powersof2(A%) = 2 ^ A%: NEXT A%
IF INSTR(A$, ".") = 0 THEN A$ = A$ + ".gif"

OPEN A$ FOR BINARY AS #2
A$ = "      ": GET #2, , A$
IF A$ <> "GIF87a" THEN PRINT "Not a GIF87a file.": END
GET #2, , TotalX: GET #2, , TotalY: GOSUB Getbytea
NumColors = 2 ^ ((A% AND 7) + 1): NoPalette = (A% AND 128) = 0
GOSUB Getbytea: Background = A%
GOSUB Getbytea: IF A% <> 0 THEN PRINT "Bad screen descriptor.": END
IF NoPalette = 0 THEN p$ = SPACE$(NumColors * 3): GET #2, , p$
DO
    GOSUB Getbytea
    IF A% = 44 THEN
        EXIT DO
    ELSEIF A% <> 33 THEN
        PRINT "Unknown extension type.": END
    END IF
    GOSUB Getbytea
    DO: GOSUB Getbytea: A$ = SPACE$(A%): GET #2, , A$: LOOP UNTIL A% = 0
LOOP
GET #2, , XStart: GET #2, , YStart: GET #2, , XLength: GET #2, , YLength
XEnd = XStart + XLength: YEnd = YStart + YLength: GOSUB Getbytea
IF A% AND 128 THEN PRINT "Can't handle local colormaps.": END
Interlaced = A% AND 64: PassNumber = 0: PassStep = 8
GOSUB Getbytea
ClearCode = 2 ^ A%
EOSCode = ClearCode + 1
FirstCode = ClearCode + 2: NextCode = FirstCode
StartCodeSize = A% + 1: CodeSize = StartCodeSize
StartMaxCode = 2 ^ (A% + 1) - 1: MaxCode = StartMaxCode

BitsIn = 0: BlockSize = 0: BlockPointer = 1
x% = XStart: y% = YStart: Ybase = y% * 320&

SCREEN 13: DEF SEG = &HA000
IF NoPalette = 0 THEN
    OUT &H3C7, 0: OUT &H3C8, 0
    FOR A% = 1 TO NumColors * 3: OUT &H3C9, ASC(MID$(p$, A%, 1)) \ 4: NEXT A%
END IF
LINE (0, 0)-(319, 199), Background, BF
DO
    GOSUB Getcodea
    IF Code <> EOSCode THEN
        IF Code = ClearCode THEN
            NextCode = FirstCode
            CodeSize = StartCodeSize
            MaxCode = StartMaxCode
            GOSUB Getcodea
            CurCode = Code: LastCode = Code: LastPixel = Code
            IF x% < 320 THEN POKE x% + Ybase, LastPixel
            x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLinea
        ELSE
            CurCode = Code: StackPointer = 0
            IF Code > NextCode THEN EXIT DO
            IF Code = NextCode THEN
                CurCode = LastCode
                OutStack(StackPointer) = LastPixel
                StackPointer = StackPointer + 1
            END IF

            DO WHILE CurCode >= FirstCode
                OutStack(StackPointer) = Suffix(CurCode)
                StackPointer = StackPointer + 1
                CurCode = Prefix(CurCode)
            LOOP

            LastPixel = CurCode
            IF x% < 320 THEN POKE x% + Ybase, LastPixel
            x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLinea

            FOR A% = StackPointer - 1 TO 0 STEP -1
                IF x% < 320 THEN POKE x% + Ybase, OutStack(A%)
                x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLinea
            NEXT A%

            IF NextCode < 4096 THEN
                Prefix(NextCode) = LastCode
                Suffix(NextCode) = LastPixel
                NextCode = NextCode + 1
                IF NextCode > MaxCode AND CodeSize < 12 THEN
                    CodeSize = CodeSize + 1
                    MaxCode = MaxCode * 2 + 1
                END IF
            END IF
            LastCode = Code
        END IF
    END IF
KEY(1) ON
LOOP UNTIL DoneFlag OR Code = EOSCode
GOTO witea

Getbytea: A$ = " ": GET #2, , A$: A% = ASC(A$): RETURN

NextScanLinea:
    IF Interlaced THEN
        y% = y% + PassStep
        IF y% >= YEnd THEN
            PassNumber = PassNumber + 1
            SELECT CASE PassNumber
            CASE 1: y% = 4: PassStep = 8
            CASE 2: y% = 2: PassStep = 4
            CASE 3: y% = 1: PassStep = 2
            END SELECT
        END IF
    ELSE
        y% = y% + 1
    END IF
    x% = XStart: Ybase = y% * 320&: DoneFlag = y% > 199
RETURN
Getcodea:
    IF BitsIn = 0 THEN GOSUB ReadBufferedBytea: LastChar = A%: BitsIn = 8
    WorkCode = LastChar \ shiftout%(BitsIn)
    DO WHILE CodeSize > BitsIn
        GOSUB ReadBufferedBytea: LastChar = A%
        WorkCode = WorkCode OR LastChar * powersof2(BitsIn)
        BitsIn = BitsIn + 8
    LOOP
    BitsIn = BitsIn - CodeSize
    Code = WorkCode AND MaxCode
RETURN
ReadBufferedBytea:
    IF BlockPointer > BlockSize THEN
        GOSUB Getbytea: BlockSize = A%
        A$ = SPACE$(BlockSize): GET #2, , A$
        BlockPointer = 1
    END IF
    A% = ASC(MID$(A$, BlockPointer, 1)): BlockPointer = BlockPointer + 1
RETURN
witea:
CLOSE #2

XNtiles% = TotalX \ 8
YNtiles% = TotalY \ 8
NumberofTiles% = XNtiles% * YNtiles%

END SUB

DEFSNG A-Z
SUB LoadMap
         TIMER OFF
         LOCATE 25, 1: INPUT ; "Mode:", savemode%
         blank
         LOCATE 25, 1: INPUT ; "Layer:", CurrentEdit%
         CurrentEdit% = CurrentEdit% - 1
         blank
         LOCATE 25, 1: INPUT ; "Load:", location$
         blank
         IF UCASE$(location$) = "C" THEN EXIT SUB
        
SELECT CASE savemode%
        CASE 0
         OPEN location$ FOR INPUT AS #1
     
         'Takes next point to read from
         FOR writeLoopY% = 0 TO 7: LINE INPUT #1, location$: NEXT writeLoopY%
         writeLoopX% = 1
         DO
         A$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         LOOP UNTIL A$ = "["
         A$ = ""
         DO
         B$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         IF B$ = "*" THEN  ELSE A$ = A$ + B$
         LOOP UNTIL B$ = "*"
         Xtiles% = VAL(A$)
         A$ = ""
         DO
         B$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         IF B$ = "]" THEN  ELSE A$ = A$ + B$
         LOOP UNTIL B$ = "]"
         Ytiles% = VAL(A$)
         'PRINT Xtiles%; "*"; Ytiles%;
         Temp& = Xtiles%
         IF Temp& * Ytiles% > 32768 THEN
                IF fileMODE = 0 THEN
                        FileArray$ = "filarray.dat"
                        OPEN FileArray$ FOR BINARY AS #2
                        fileMODE = 1
                END IF
         ELSE
                REDIM map(Xtiles%, Ytiles%, 3) AS INTEGER
         END IF
         FOR writeLoopY% = 0 TO Ytiles% - 1
                FOR writeLoopX% = 0 TO Xtiles% - 1
                        INPUT #1, A$
                        IF A$ = "" THEN INPUT #1, A$
                      
                                tempTextTile.paletteNumber = fromHex%(A$, 3)
                                tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                      
                        IF fileMODE = 1 THEN
                                putRecord 2, writeLoopX%, writeLoopY%, Xtiles%, decimal(tempTextTile), 1
                        ELSE
                                map(writeLoopX%, writeLoopY%, CurrentEdit%) = decimal(tempTextTile)
                        END IF
                NEXT writeLoopX%
                Temp& = Xtiles%
                Temp2& = writeLoopX%
                Temp2& = ((Temp2& * writeLoopY%) / (Temp& * Ytiles%)) * 100
                LOCATE 25, 1: PRINT "Loading "; Temp2&; "% complete";
         NEXT writeLoopY%
         CLOSE #1
         TIMER ON
CASE 1
         OPEN location$ FOR INPUT AS #1
        
         'Takes next point to read from
         FOR writeLoopY% = 0 TO 7: LINE INPUT #1, location$: NEXT writeLoopY%
         writeLoopX% = 1
         DO
         A$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         LOOP UNTIL A$ = "["
         A$ = ""
         DO
         B$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         IF B$ = "*" THEN  ELSE A$ = A$ + B$
         LOOP UNTIL B$ = "*"
         Xtiles% = VAL(A$)
         A$ = ""
         DO
         B$ = MID$(location$, writeLoopX%, 1)
         writeLoopX% = writeLoopX% + 1
         IF B$ = "]" THEN  ELSE A$ = A$ + B$
         LOOP UNTIL B$ = "]"
         Ytiles% = VAL(A$)
         nosectionsX% = Xtiles% / 32
         nosectionsY% = Ytiles% / 32
         Temp& = Xtiles%
         IF Temp& * Ytiles% > 32768 THEN
                IF fileMODE = 0 THEN
                        FileArray$ = "filarray.dat"
                        OPEN FileArray$ FOR BINARY AS #2
                        fileMODE = 1
                END IF
         ELSE
                'REDIM map(Xtiles%, Ytiles%, 3) AS INTEGER
         END IF
        
        FOR sectionLoopY% = 0 TO nosectionsY% - 1
        FOR sectionLoopX% = 0 TO nosectionsX% - 1
         FOR writeLoopY% = (sectionLoopY% * 32) TO ((sectionLoopY%) * 32) + 31
                FOR writeLoopX% = (sectionLoopX% * 32) TO ((sectionLoopX%) * 32) + 31
                        INPUT #1, A$
                        IF A$ = "" THEN INPUT #1, A$
                      
                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                     
                        IF fileMODE = 1 THEN
                                putRecord 2, writeLoopX%, writeLoopY%, Xtiles%, decimal(tempTextTile), 1
                        ELSE
                                map(writeLoopX%, writeLoopY%, CurrentEdit%) = decimal(tempTextTile)
                        END IF
                NEXT writeLoopX%
         NEXT writeLoopY%
        NEXT sectionLoopX%
                Temp& = Xtiles%
                Temp2& = sectionLoopX%
                Temp2& = ((Temp2& * sectionLoopY% * 1024) / (Temp& * Ytiles%)) * 100
                LOCATE 25, 1: PRINT "Loading "; Temp2&; "% complete";
        NEXT sectionLoopY%
         CLOSE #1
         TIMER ON
END SELECT
CLS
border
END SUB

SUB putRecord (filenum%, x%, y%, xsize%, byte AS INTEGER, numrecs%)
        Temp& = y%
        Temp& = (Temp& * xsize% * numrecs% * 2)
        SEEK filenum%, (x% * numrecs% * 2 + 1) + Temp&
        PUT filenum%, SEEK(filenum%), byte
        'PUT filenum%, SEEK(filenum%), byte.VF
        'PUT filenum%, SEEK(filenum%), byte.HF
        'PUT filenum%, SEEK(filenum%), byte.tileNumber
END SUB

FUNCTION save%
TIMER OFF
         LOCATE 25, 1: INPUT ; "Mode:", savemode%
         blank
         LOCATE 25, 1: INPUT ; "Layer:", CurrentEdit%
         CurrentEdit% = CurrentEdit% - 1
         blank
         LOCATE 25, 1: INPUT ; "Save where:", location$
         blank
         IF UCASE$(location$) = "C" THEN EXIT FUNCTION
         
SELECT CASE savemode%
        CASE 0
         OPEN location$ FOR OUTPUT AS #1
        
         PRINT #1, "/***********************************\"
         PRINT #1, "|                                   |"
         PRINT #1, "| Exported by Ice D                 |"
         PRINT #1, "| Using: NME V0.45 Mode 0           |"
         PRINT #1, "| http://icedevelopment.funky.as    |"
         PRINT #1, "|                                   |"
         PRINT #1, "\***********************************/"
       
        
         PRINT #1, ("const u16 map[ " + STR$(Xtiles%) + "*" + STR$(Ytiles%) + " ] = {")
        
         FOR writeLoopY% = 0 TO Ytiles% - 1
                FOR writeLoopX% = 0 TO Xtiles% - 1
                        IF fileMODE = 1 THEN
                                setRecord 2, writeLoopX%, writeLoopY%, Xtiles%, 1
                                GET 2, , tempTextTile.tileNumber
                                A$ = "0x" + tohexD$(tempTextTile.tileNumber)
                     
                                tempTextTile.paletteNumber = fromHex%(A$, 3)
                                tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                     
                                PRINT #1, ("0x" + tohex$(tempTextTile));
                        ELSE
                                TMAP = map(writeLoopX%, writeLoopY%, CurrentEdit%)
                                A$ = "0x" + tohexD$(TMAP)
                     
                                tempTextTile.paletteNumber = fromHex%(A$, 3)
                                tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)

                                PRINT #1, ("0x" + tohex$(tempTextTile));
                        END IF
                        IF writeLoopX% = Xtiles% - 1 THEN PRINT #1, "," ELSE PRINT #1, ",";
                NEXT writeLoopX%
                Temp& = Xtiles%
                Temp2& = writeLoopX%
                Temp2& = ((Temp2& * writeLoopY%) / (Temp& * Ytiles%)) * 100
                LOCATE 25, 1: PRINT "Saving "; Temp2&; "% complete";
         NEXT writeLoopY%
        
         PRINT #1, "};"
         PRINT #1, ""
         CLOSE #1
         TIMER ON
         save = 1
CASE 1
        LOCATE 25, 1: INPUT ; "nosectionsX:", nosectionsX%
        blank
        LOCATE 25, 1: INPUT ; "nosectionsY:", nosectionsY%
        blank
         OPEN location$ FOR OUTPUT AS #1
       
         PRINT #1, "/***********************************\"
         PRINT #1, "|                                   |"
         PRINT #1, "| Exported by Ice D                 |"
         PRINT #1, "| Using: NME V0.45 Mode 1           |"
         PRINT #1, "| http://icedevelopment.funky.as    |"
         PRINT #1, "|                                   |"
         PRINT #1, "\***********************************/"

         PRINT #1, ("const u16 map[" + STR$(Ytiles%) + "*" + STR$(Ytiles%) + " ] = {")
         
        FOR sectionLoopY% = 0 TO nosectionsY% - 1
        FOR sectionLoopX% = 0 TO nosectionsX% - 1
         FOR writeLoopY% = (sectionLoopY% * 32) TO ((sectionLoopY%) * 32) + 31
                FOR writeLoopX% = (sectionLoopX% * 32) TO ((sectionLoopX%) * 32) + 31
                        IF fileMODE = 1 THEN
                                setRecord 2, writeLoopX%, writeLoopY%, Xtiles%, 1
                                GET 2, , tempTextTile.tileNumber
                                A$ = "0x" + tohexD$(tempTextTile.tileNumber)
                     
                                tempTextTile.paletteNumber = fromHex%(A$, 3)
                                tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                      
                                PRINT #1, ("0x" + tohex$(tempTextTile));
                        ELSE
                                TMAP = map(writeLoopX%, writeLoopY%, CurrentEdit%)
                                A$ = "0x" + tohexD$(TMAP)
                    
                                tempTextTile.paletteNumber = fromHex%(A$, 3)
                                tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)

                                PRINT #1, ("0x" + tohex$(tempTextTile));
                        END IF
                        IF writeLoopX% >= ((sectionLoopX%) * 32) + 31 THEN PRINT #1, "," ELSE PRINT #1, ",";
                NEXT writeLoopX%

         NEXT writeLoopY%
        NEXT sectionLoopX%
                Temp& = Xtiles%
                Temp2& = sectionLoopX%
                Temp2& = ((Temp2& * sectionLoopY% * 1024) / (Temp& * Ytiles%)) * 100
                LOCATE 25, 1: PRINT "Saving "; Temp2&; "% complete";
        NEXT sectionLoopY%
        
         PRINT #1, "};"
         PRINT #1, ""
         CLOSE #1
         TIMER ON
         save = 1

END SELECT
CLS
border
END FUNCTION

SUB SetPalette

END SUB

SUB setRecord (filenum%, x%, y%, xsize%, numrecs%)
        Temp& = y%
        Temp& = (Temp& * xsize% * numrecs% * 2)
        SEEK filenum%, (x% * numrecs% * 2 + 1) + Temp&
END SUB

FUNCTION tohex$ (Atile AS TextTile)
        'DIM binString AS STRING * 16
        'DIM hexString AS STRING * 16
        binString$ = binary$(Atile)
        FOR x = 0 TO 3
                IF MID$(binString$, (x * 4) + 1, 4) = "0000" THEN hexString$ = hexString$ + "0"
                IF MID$(binString$, (x * 4) + 1, 4) = "0001" THEN hexString$ = hexString$ + "1"
                IF MID$(binString$, (x * 4) + 1, 4) = "0010" THEN hexString$ = hexString$ + "2"
                IF MID$(binString$, (x * 4) + 1, 4) = "0011" THEN hexString$ = hexString$ + "3"
                IF MID$(binString$, (x * 4) + 1, 4) = "0100" THEN hexString$ = hexString$ + "4"
                IF MID$(binString$, (x * 4) + 1, 4) = "0101" THEN hexString$ = hexString$ + "5"
                IF MID$(binString$, (x * 4) + 1, 4) = "0110" THEN hexString$ = hexString$ + "6"
                IF MID$(binString$, (x * 4) + 1, 4) = "0111" THEN hexString$ = hexString$ + "7"
                IF MID$(binString$, (x * 4) + 1, 4) = "1000" THEN hexString$ = hexString$ + "8"
                IF MID$(binString$, (x * 4) + 1, 4) = "1001" THEN hexString$ = hexString$ + "9"
                IF MID$(binString$, (x * 4) + 1, 4) = "1010" THEN hexString$ = hexString$ + "A"
                IF MID$(binString$, (x * 4) + 1, 4) = "1011" THEN hexString$ = hexString$ + "B"
                IF MID$(binString$, (x * 4) + 1, 4) = "1100" THEN hexString$ = hexString$ + "C"
                IF MID$(binString$, (x * 4) + 1, 4) = "1101" THEN hexString$ = hexString$ + "D"
                IF MID$(binString$, (x * 4) + 1, 4) = "1110" THEN hexString$ = hexString$ + "E"
                IF MID$(binString$, (x * 4) + 1, 4) = "1111" THEN hexString$ = hexString$ + "F"
        NEXT x
        tohex$ = hexString$
END FUNCTION

FUNCTION tohexD$ (number AS INTEGER)
        binString$ = binaryD$(number)
        FOR x = 0 TO 3
                IF MID$(binString$, (x * 4) + 1, 4) = "0000" THEN hexString$ = hexString$ + "0"
                IF MID$(binString$, (x * 4) + 1, 4) = "0001" THEN hexString$ = hexString$ + "1"
                IF MID$(binString$, (x * 4) + 1, 4) = "0010" THEN hexString$ = hexString$ + "2"
                IF MID$(binString$, (x * 4) + 1, 4) = "0011" THEN hexString$ = hexString$ + "3"
                IF MID$(binString$, (x * 4) + 1, 4) = "0100" THEN hexString$ = hexString$ + "4"
                IF MID$(binString$, (x * 4) + 1, 4) = "0101" THEN hexString$ = hexString$ + "5"
                IF MID$(binString$, (x * 4) + 1, 4) = "0110" THEN hexString$ = hexString$ + "6"
                IF MID$(binString$, (x * 4) + 1, 4) = "0111" THEN hexString$ = hexString$ + "7"
                IF MID$(binString$, (x * 4) + 1, 4) = "1000" THEN hexString$ = hexString$ + "8"
                IF MID$(binString$, (x * 4) + 1, 4) = "1001" THEN hexString$ = hexString$ + "9"
                IF MID$(binString$, (x * 4) + 1, 4) = "1010" THEN hexString$ = hexString$ + "A"
                IF MID$(binString$, (x * 4) + 1, 4) = "1011" THEN hexString$ = hexString$ + "B"
                IF MID$(binString$, (x * 4) + 1, 4) = "1100" THEN hexString$ = hexString$ + "C"
                IF MID$(binString$, (x * 4) + 1, 4) = "1101" THEN hexString$ = hexString$ + "D"
                IF MID$(binString$, (x * 4) + 1, 4) = "1110" THEN hexString$ = hexString$ + "E"
                IF MID$(binString$, (x * 4) + 1, 4) = "1111" THEN hexString$ = hexString$ + "F"
        NEXT x
        tohexD$ = hexString$

END FUNCTION

SUB updateScrBuff (fx%, tx%, fy%, ty%)
        FOR y% = fy% TO ty%
                FOR x% = fx% TO tx%
                        IF x% + Xstep% < Xtiles% AND y% + Ystep% < Ytiles% THEN
                        IF fileMODE = 1 THEN
                                setRecord 2, x% + Xstep%, y% + Ystep%, Xtiles%, 1
                                GET 2, , tempTextTile.tileNumber
                                A$ = "0x" + tohexD$(tempTextTile.tileNumber)
                                tempTextTile.paletteNumber = fromHex%(A$, 3)
                                tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 0
                        ELSE
                                SELECT CASE ShowMaps
                                CASE 1
                                        CurrentEdit% = 0
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 0)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 0
                                CASE 2
                                        CurrentEdit% = 1
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 1)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 0
                                CASE 3
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 0)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 0
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 1)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 1
                                CASE 4
                                        CurrentEdit% = 2
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 2)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 0
                                CASE 5
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 0)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 0
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 2)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 1
                                CASE 6
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 1)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 0
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 2)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 1
                                CASE 7
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 0)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 0
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 1)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 1
                                        TMAP = map(x% + Xstep%, y% + Ystep%, 2)
                                        A$ = "0x" + tohexD$(TMAP)
                                        tempTextTile.paletteNumber = fromHex%(A$, 3)
                                        tempTextTile.VF = binIndex%(fromHex%(A$, 4), 1)
                                        tempTextTile.HF = binIndex%(fromHex%(A$, 4), 2)
                                        tempTextTile.tileNumber = (binIndex%(fromHex%(A$, 4), 3) * 2 ^ 9) + (binIndex%(fromHex%(A$, 4), 4) * 2 ^ 8) + (fromHex%(A$, 5) * 16) + fromHex%(A$, 6)
                                        drawTile x%, y%, tempTextTile.tileNumber, ScnBuf%(), DBSXS&, tempTextTile.HF, tempTextTile.VF, 1
                                END SELECT
                        END IF
                        END IF
                NEXT x%
        NEXT y%
END SUB

